'	Horloge_balance.bas - led clock with beam BS1 source code
'	(c) 2006 Serge Glaentzlin
'
' Program Horloge_balance.bas   release for SX18DP
' Program driver for led CLOCK with beam
' Date of creation : 06/06/06
'output 6   data output
'output 5   clock
'output 7   triger
'input  3   external clock (2 HZ)
'input  4 and 2   connected to two push button to set the minutes and the hours

'
'                    Display guide

' the next lines give from output 0 to 7 the matching with the identification of the led on the PCB :
' 
'CI7 : M13   M14   M15   M16   M17   M18   M19   M20
'CI5 : M04   M05   M06   M08   M09   M10   M11   M12
'CI9 : H07   H08   H09   H10   H11   M01   M02   M03
'CI4 : M53   M54   M55   M56   M57   M58   M59   NC
'CI3 : M45   M46   M47   M48   M49   M50   M51   M52
'CI2 : M37   M38   M39   M40   M41   M42   M43   M44
'CI1 : M29   M30   M31   M32   M33   M34   M35   M36
'CI8 : M21   M22   M23   M24   M25   M26   M27   M28
'CI11: D03   D01   H01   H02   H03   H04   H05   H06
'CI6 : D04   D05   D06   D07   D08   D09   D10   D11
'CI12: NC    M07   B5    B4    B3    B2    B1    D02    

'the M** are the minutes, the H** are the hours, the D** the groups of five secondes, the B* the beam
'We store this values in the EEPROM of the sx with the next rules :
' number from one to 59 for the M** (sample : M15 is the 15th minute led and stored 15)
' number from 61 to 72 for the D**  (sample : D04 is the 4th led from the rhombus and stored 60+ 4=64
' number from 81 to 92 for the H**  (sample : H11 is the 11th hour led and stored 80+11=91)
' number from 96 to 100 for the B*  (sample : B3  is the third led of the beam and stored 96+3=99
' the storage begins with the last output of CI12

EEPROM (0,7,100,99,98,97,96,62  ,64,65,66,67,68,69,70,71 ,63,61,81,82,83,84,85,86 )
EEPROM (21,22,23,24,25,26,27,28 ,29,30,31,32,33,34,35,36 ,37,38,39,40,41,42,43,44)
EEPROM (45,46,47,48,49,50,51,52 ,53,54,55,56,57,58,59,0  ,87,88,89,90,91,1,2,3)
EEPROM (4,5,6,8,9,10,11,12      ,13,14,15,16,17,18,19,20  )  

Symbol MINUT   = b2 ' current minute
Symbol HEURE   = b3 ' current hour
Symbol DIZSEC  = b4 ' current group of five seconds 
Symbol SECONDE = b5 ' current second in the group of five seconds
'b6  working variable
'b7  working variable
'b8  working variable
'BIT1 : Direction of the beam contents +1 or -1
Symbol AJUST   =  W5 'variable for time adjustement
Symbol CPT     =  B9 'external clock counter
Symbol BALANC  =  B12 'Number of the beam led to light on
dirs=%11100000
pins=%00000000
BIT1=1
BALANC=1

debut:

if pin2=%0 then suite1
pause 300
goto regminute

suite1:
if pin4=%0 then suite2
pause 300
goto regheure

suite2:

if pin3 = bit0 then tic

goto debut

tic:
if bit0=1  then tic1
bit0=1
goto tic2
tic1:
bit0=0
tic2:
CPT=CPT+1
IF CPT<2 then debut
CPT=0
'
' The external clock  is based on 32760 hz quartz, wich signal is divided by 16384
' by the hardware. So we detect a changing on pin3 four times in a second. We have 
' to adjust the time by adding a second every 4095 seconds because 32760 is not exactly  
' a multiple of 2**14 (32768). We lose 8/32760 second every second
'
IF BIT1=0 THEN BALAN_1
  BALANC=BALANC+1
  GOTO BALAN_2
BALAN_1:
  BALANC=BALANC-1
BALAN_2:
if BALANC<>5 AND BALANC<>1 AND BALANC<>3 THEN affichage
  AJUST=AJUST+1
  SECONDE=SECONDE+1
'
' time adjustment
'
  IF AJUST<4095 THEN BALAN_25
  SECONDE=SECONDE+1
  AJUST=0
  IF SECONDE<5 then BALAN_25
  SECONDE=1
'
' end of adjustment
'
BALAN_25:
'
' direction change of the beam is at 1 or 5
'
IF BALANC <> 5 AND BALANC<>1 THEN T_SECOND
IF BIT1=1  THEN BALAN_3
  BIT1=1
  GOTO T_SECOND 
BALAN_3:
  BIT1=0
  
T_SECOND:

if SECONDE < 5 then affichage
SECONDE=SECONDE-5

DIZSEC=DIZSEC+1
if DIZSEC<12 then affichage
DIZSEC=0
regminute:
MINUT=MINUT+1
if MINUT<60 then affichage
MINUT=0
regheure:
HEURE=HEURE+1
if HEURE<12  then affichage
heure=0
'
'serial loading of then clock components 
' and triging 
'
affichage:

FOR B6 = 0 to 87 
read b6,b7
IF B7>60 then  CINQS

'minutes leds

B8=MINUT
   GOTO MEM_AFF 

cinqs:
IF B7>72 then t_heure

' group  of five seconds leds

B7=B7-60
   B8=DIZSEC 
   GOTO MEM_AFF

t_heure:
IF B7>92 then t_balanc

' hours leds

B7=B7-80
   B8=HEURE 
   GOTO MEM_AFF

t_balanc:

'case of output not affected to a led

IF b7=0 then MEM_AFF

' beam leds

   B7=B7-95
   pin6=%0 
  IF BALANC<>B7 then mem_af0
   pin6=%1
  goto mem_af0
  
mem_aff:
   pin6=%0 
   IF B8<B7 then mem_af0
    pin6=%1
mem_af0:
   pulsout 7,1


next B6

' triging for display
pulsout 5,1
goto debut



